;--------------------- Using GCC Extensions to ANSI C... ---------------------

(provide 'gcc)
(require 'ansic)


;------ Enabling some extensions ------
(define C:inline 'inline)
(define *INSTRUCTION-TYPE* 'LABEL)


"
;------ Threaded code using labels as first class objects ------
;   See threading.scm

(define (make-instruction-dispatcher)
   (let*
      ((dispatch-omp
   (omp:fork 
define({__INSTR_LABEL__INIT__},		{$1$2 ();})
define({__INSTR_LABEL__EXIT__},		{goto $1__exit;})
define({__INSTR_LABEL__HEADERS__},{
  __HEADER__({
  void $1$2 (void)
  BEGIN
  })

  __CODE__({
  __INSTR_LABEL__next__
  })

  __ENDCODE__({
  $1__exit:
  })

  __FOOTER__({
  END
  })
})
define({__INSTR_LABEL__type__},		{void *})
define({__INSTR_LABEL__decl__},		{$1: $2;})
define({__INSTR_LABEL__val__},		{&&$1})
define({__INSTR_LABEL__enter__},	{__PRE_GET_NEXT_INSTR__})
define({__INSTR_LABEL__next__},		{__GET_NEXT_INSTR__
		goto *__NEXT_INSTR__;})
define({__INSTR_LABEL__next_follows__},	{1})
define({__INSTR_LABEL__does_forward__},	{1})

"
